# AIOComedi
Release code for ACCES I/O Products Comedi Drivers
=======
# Instructions for building comedi drivers

The following is a simple sequence of steps that will both 
download the latest version of comedilib and the comedi kernel
module for compilation and installation.


```bash
git clone https://github.com/accesio/comedi_development
cd comedi_development
. commands.sh
build_acces
mload accespci
```

**_build_acces_** will perform the steps of downloading both comedi
and comedilib. After it has completed this step , build_acces will run
the **configure** script that is common with autoconf build systems
and then run make which will build both comedi and comedlib in place.
After both of these makes have run , whereby comedi and comedilib will get built, 
**build_acces** will then build the ACCES I/O comedi drivers. This
process **will not** install any software, but instead leaves code
compiled under the comedi_development directory.


## PCI Drivers

PCI drivers can be installed using aliases / functions that have
been provided by the commands.sh sourceme file.

For instance, to install the ACCES I/O PCI drivers you would do the
following

```bash
mload accespci
```



## Testing

The easiest way to test your cards is to use the utility functions provided
in the demos directory. Here are some sample tests that you would most
likely need to run.

First, cd to the demo directory of comedi_development

```
cd comedi_development/comedlib/demo
```

### IIRO8 

#### An example that toggles the relays with a one second sleep
in between. This assumes that your IIRO device has been assigned
to /dev/comedi0.  


```bash
for((c=0;$c<=7;c=c+1)); 
do 
for((on=0;$on<=1;on=$on+1)); 
do outp -s 0 -c $c $on; 
sleep 1; 
done; 
done
```

In this case, we are using Subdevice 0 which is the digital In/Out
subdevice on the IIRO8


#### An example that reads
```
inp -s 1
```

