#!/bin/bash


for((c=0;$c<=7;c=$c+1)) ; do outp -s 0 -c $c 0 >/dev/null;  done


function zig_zag { 
    sub=$1

    if [ -z "$sub" ] ; then
        sub=0
    fi
    for ((c=0;$c<=7;c=$c+1)); do
        expression=$(eval $2 2>/dev/null)
        if [ -z "${expression}" ] ; then
            expression=0
        fi
        exp=$(outp -s 0 -c $c $expression)
        echo -ne "$exp"
    done
    echo -ne "\n"
}


function tap_test {
    if [ "$1" == "$2" ] ; then
        echo "ok # ${3}"
    else
        echo "not ok # ${1} != ${2}  ${3}"
    fi
}

function get_all_subdevice {
    sub=$1
    for ((c=0;$c<=7;c=$c+1)); do
        echo -ne "$(inp -s $sub -c $c)"
    done
    echo -ne "\n"        
    
}


result=$(zig_zag 0)
in_out=$(get_all_subdevice 0)
tap_test $result $in_out "All zeros ok for In/Out"
in_only=$(get_all_subdevice 1)
tap_test $result $in_only "All zeros ok for Inonly"

result=$(zig_zag 0 'expr 1 == 1')
in_out=$(get_all_subdevice 0)
tap_test $result $in_out "All ones ok for In/Out"
in_only=$(get_all_subdevice 1)
tap_test $result $in_only "All ones ok for Inonly"

result=$(zig_zag 0 'expr $c % 2')
in_out=$(get_all_subdevice 0)
tap_test $result $in_out "zigzag ok for In/Out"
in_only=$(get_all_subdevice 1)
tap_test $result $in_only "zigzag ok for Inonly"


