#!/bin/bash

if [ -z "${COMEDI_DEV_ROOT}" ] ; then
    echo "You have not sourced the file commands.sh yet"
    /bin/echo -ne "please do the following\n\n"
    echo "  cd .. && source commands.sh && cd -"
    exit 1
fi

function setall_outputs() { 
    value=$1
    incr=$2
    if [ -z $incr ] ; then
        incr=1
    fi
    for((i=0;$i<=7;i=$i+${incr}))
    do
        ${COMEDI_DEMO}/outp -s 0 -c $i $value > /dev/null
    done
}

function read_subdevice() {
    subdev=$1
    for((i=0;$i<=7;i=$i+1))
    do
        ${COMEDI_DEMO}/inp -s ${subdev} -c $i | perl -pne 'chomp'
    done
    echo ""
}

function delayed_setall_outputs() {
    delay=$1
    value=$2
    incr=$3
    sleep $delay
    setall_outputs $value $incr
}


echo "Setting outputs to all 1's"
setall_outputs  1 1 
read_subdevice 0

echo "Setting outputs to all 0's"
setall_outputs  0 1 
read_subdevice 0

echo "Demonstrating Reading from Output port channels 0-7"
read_subdevice 0

#
# 
#
echo "Make sure you have hooked up a loopback cable from Outputs to the Inputs"
sleep 1

echo "Demonstrating Reading from Input port channels 0-7"
read_subdevice 1

#
#
#
echo "Resetting the outputs to all zeros"
setall_outputs 0 1 


echo "Performing an IRQ wait / read"
delayed_setall_outputs 2 1 1 &
echo "Now going to wait for IRQ's to change the Input values"
${COMEDI_DEMO}/cmd -s 1 -N 8
